#include "Builder.h"

#include "BuilderImpl.h"
#include "llvm/Support/Casting.h"
// #include "mlir/Dialect/StandardOps/Ops.h"
// #include "mlir/IR/Attributes.h"
// #include "mlir/IR/Operation.h"
// #include "mlir/IR/StandardTypes.h"
// #include "mlir/IR/Types.h"
// #include "mlir/IR/Value.h"
#include "Attribute.h"
#include "AttributeImpl.h"
#include "Op.h"
#include "OpImpl.h"
#include "mlir-hlo/Dialect/mhlo/IR/hlo_ops.h"
#include "mlir-hlo/Dialect/mhlo/transforms/PassDetail.h"
#include "mlir-hlo/Dialect/mhlo/transforms/passes.h"

namespace builder {

Builder::Builder() : impl_(std::make_shared<Impl>()) {}

builder::Op Builder::CreateInput(const builder::Type& type) {
  return impl_->CreateInput(type);
}

void Builder::SetOutput(const std::vector<builder::Op>& outputs) {
  impl_->SetOutput(outputs);
}

void Builder::DumpModule() { impl_->DumpModule(); }

}  // namespace builder

#define GET_OP_CLASSES
#include "include/mlir-hlo/Dialect/mhlo/IR/hlo_builder.cc.inc"
